<template>
  <section class="extra" :class="{ 'extra--info-hidden': !showMoreInfo }">
    <div class="extra__inner">
      <!-- The image URL would point to a cloud service in a real app -->
      <img class="extra__image" :src="extra.imageURL" />
      <div class="extra__text">
        <header>
          <h3 class="extra__name">{{ extra.name }}</h3>
        </header>
        <p class="extra__description">{{ extra.description }}</p>
        <div class="extra__more-info-toggle" @click="showMoreInfo = !showMoreInfo">
          Más información y condiciones
          <img
            class="extra__dropdown"
            src="../../assets/images/layout/angle-down-blue.svg"
            alt="dropdown"
          />
        </div>
      </div>
    </div>
    <!-- The below content visibility can be toggled by the user -->
    <div
      class="more-info extra__more-info"
      :style="{ height: moreInfoHeight + 'px' }"
      ref="moreInfo"
    >
      <p class="more-info__includes-text">Incluye</p>
      <ul class="more-info__feature-list">
        <!-- I use index as id because these elements never need to be modified dynamically -->
        <li class="more-info__feature" v-for="(feature, i) in extra.features" :key="i">{{ feature }}</li>
      </ul>
      <p class="more-info__terms">{{ extra.terms }}</p>
    </div>
  </section>
</template>

<script>
export default {
  name: 'Extra',
  props: {
    extra: Object,
  },
  data() {
    return {
      // Initial values
      showMoreInfo: false,
      moreInfoHeight: null,
    };
  },
  mounted() {
    // requestAnimationFrame needed because
    // when mounted() triggers document is still not fully loaded
    requestAnimationFrame(() => {
      // Unlike in ExtraCategory, moreInfo can always stay at a fixed height while unfolded
      // We calculate that height only once, based on the current contents it has inside
      // This height is overriden by css !important when moreInfo is folded
      this.moreInfoHeight = this.$refs.moreInfo.scrollHeight;
    });
  },
};
</script>

<style lang="scss" scoped>
// I would justifiy all the text, but I keep it like the mockup
.extra {
  display: flex;
  flex-direction: column;
  // inset shadow so it dosen't overlap with outer shadow
  box-shadow: $primary-inset-box-shadow;
}

.extra__inner {
  display: flex;
  flex-wrap: wrap;
  // in order to center image when the text wraps
  justify-content: center;
  // So it looks similar to the mock-up
  max-width: 1000px;
}

.extra__image {
  max-width: 100%;

  @include for-tablet-up {
    max-width: 300px;
  }
}

.extra__text {
  display: flex;
  // this will make the text wrap on mobiles
  flex: 1 300px;
  flex-direction: column;
  padding: 25px;

  @include for-tablet-up {
    padding: 40px 30px 15px;
  }

  @include for-desktop-up {
    padding: 20px 30px 15px;
  }
}

.extra__name {
  @include font-roboto-slab-bold(1.125rem, $primary-dark);
  margin-bottom: 6px;
}

.extra__description {
  @include font-roboto(0.875rem, $gray-text);
}

.extra__more-info-toggle {
  @include font-roboto-bold(0.875rem, $primary-light);
  display: flex;
  align-items: flex-end;
  height: 40px; // for when parent block wraps
  margin-top: auto;
  cursor: pointer;
}

.extra__dropdown {
  position: relative;
  bottom: 4px;
  width: 1em;
  margin-left: 1em;
  transform: rotateX(180deg);
  transition: transform 0.5s;

  .extra--info-hidden & {
    transform: rotateX(0);
  }
}

.more-info {
  max-width: 1000px;
  padding: 0 50px;
  overflow: hidden;
  transition: height 0.5s;

  .extra--info-hidden & {
    // !important so it can override JS calulated value
    height: 0 !important;
  }
}

.more-info__includes-text {
  padding-top: 30px;
  font-size: 1rem;
}

.more-info__feature-list {
  @include font-roboto(0.875rem, $gray-text);
  margin-bottom: 40px;
  // reduce default list padding
  padding-left: 15px;

  @include for-tablet-up {
    column-gap: 40px;
    column-fill: balance;
    column-count: 2;
  }

  @include for-desktop-up {
    column-count: 3;
  }
}

.more-info__feature {
  margin-bottom: 5px;
}

.more-info__terms {
  @include font-roboto-bold(0.875rem, $primary-dark);
  padding-bottom: 20px;
}
</style>
